---
title: String.prototype.split()
slug: Web/JavaScript/Reference/Global_Objects/String/split
tags:
  - JavaScript
  - Method
  - Prototype
  - Reference
  - Regular Expressions
  - String
---
<div>{{JSRef}}</div>

<p><span class="seoSummary">The <strong><code>split()</code></strong> method divides a {{jsxref("String")}} into an ordered list of substrings, puts these substrings into an array, and returns the array.  The division is done by searching for a pattern; where the pattern is provided as the first parameter in the method's call.  </span></p>

<div>{{EmbedInteractiveExample("pages/js/string-split.html", "taller")}}</div>

<div class="hidden">The source for this interactive example is stored in a GitHub repository. If you'd like to contribute to the interactive examples project, please clone <a href="https://github.com/mdn/interactive-examples">https://github.com/mdn/interactive-examples</a> and send us a pull request.</div>

<h2 id="Syntax">Syntax</h2>

<pre class="syntaxbox notranslate"><var>str</var>.split([<var>separator</var>[, <var>limit</var>]])</pre>

<h3 id="Parameters">Parameters</h3>

<dl>
 <dt><code><var>separator</var></code> {{optional_inline}}</dt>
 <dd>
 <p>The pattern describing where each split should occur.  The <code><var>separator</var></code> can be a simple string or it can be a {{jsxref("Global_Objects/RegExp", "regular expression", "", 1)}}.</p>

 <ul>
  <li>The simplest case is when <code><var>separator</var></code> is just a single character; this is used to split a delimited string.  For example, a string containing tab separated values (TSV) could be parsed by passing a tab character as the separator, like this: <code>myString.split("\t")</code>.</li>
  <li>If <code><var>separator</var></code> contains multiple characters, that entire character sequence must be found in order to split.</li>
  <li>If <code><var>separator</var></code> is omitted or does not occur in <code><var>str</var></code>, the returned array contains one element consisting of the entire string.</li>
  <li>If <code><var>separator</var></code> appears at the beginning (or end) of the string, it still has the effect of splitting.  The result is an empty (i.e. zero length) string, which appears at the first (or last) position of the returned array.</li>
  <li>If <code><var>separator</var></code> is an empty string (<code>""</code>), <code><var>str</var></code> is converted to an array of each of its UTF-16 "characters".</li>
 </ul>

 <div class="notecard warning">
 <p><strong>Warning:</strong> When the empty string (<code>""</code>) is used as a separator, the string is <strong>not</strong> split by <em>user-perceived characters</em> (<a href="https://unicode.org/reports/tr29/#Grapheme_Cluster_Boundaries">grapheme clusters</a>) or unicode characters (codepoints), but by UTF-16 codeunits. This destroys <a href="http://unicode.org/faq/utf_bom.html#utf16-2">surrogate pairs</a>. See <a href="https://stackoverflow.com/a/34717402">“How do you get a string to a character array in JavaScript?” on StackOverflow</a>.</p>
 </div>
 </dd>
 <dt><code><var>limit</var></code> {{optional_inline}}</dt>
 <dd>
 <p>A non-negative integer specifying a limit on the number of substrings to be included in the array. If provided, splits the string at each occurrence of the specified <code><var>separator</var></code>, but stops when <code><var>limit</var></code> entries have been placed in the array. Any leftover text is not included in the array at all.</p>

 <ul>
  <li>The array may contain fewer entries than <code>limit</code> if the end of the string is reached before the limit is reached.</li>
  <li>If <code><var>limit</var></code> is <code>0</code>, <code>[]</code> is returned.</li>
 </ul>
 </dd>
</dl>

<h3 id="Return_value">Return value</h3>

<p>An {{jsxref("Array")}} of strings, split at each point where the <code><var>separator</var></code> occurs in the given string.</p>

<h2 id="Description">Description</h2>

<p>When found, <code><var>separator</var></code> is removed from the string, and the substrings are returned in an array.</p>

<p>If <code><var>separator</var></code> is a regular expression with capturing parentheses, then each time <code><var>separator</var></code> matches, the results (including any <code>undefined</code> results) of the capturing parentheses are spliced into the output array.</p>

<p>If the separator is an array, then that Array is coerced to a String and used as a separator.</p>

<h2 id="Examples">Examples</h2>

<h3 id="Using_split">Using <code>split()</code></h3>

<div id="split_empty_string">
<p>When the string is empty, <code>split()</code> returns an array containing one empty string, rather than an empty array. If the string and separator are both empty strings, an empty array is returned.</p>

<pre class="brush: js notranslate">const myString = ''
const splits = myString.split()

console.log(splits)

// ↪ [""]
</pre>
</div>

<p>The following example defines a function that splits a string into an array of strings using <code><var>separator</var></code>. After splitting the string, the function logs messages indicating the original string (before the split), the separator used, the number of elements in the array, and the individual array elements.</p>

<pre class="brush: js notranslate">function splitString(stringToSplit, separator) {
  const arrayOfStrings = stringToSplit.split(separator)

  console.log('The original string is: ', stringToSplit)
  console.log('The separator is: ', separator)
  console.log('The array has ', arrayOfStrings.length, ' elements: ', arrayOfStrings.join(' / '))
}

const tempestString = 'Oh brave new world that has such people in it.'
const monthString = 'Jan,Feb,Mar,Apr,May,Jun,Jul,Aug,Sep,Oct,Nov,Dec'

const space = ' '
const comma = ','

splitString(tempestString, space)
splitString(tempestString)
splitString(monthString, comma)
</pre>

<p>This example produces the following output:</p>

<pre class="notranslate">The original string is: "Oh brave new world that has such people in it."
The separator is: " "
The array has 10 elements: Oh / brave / new / world / that / has / such / people / in / it.

The original string is: "Oh brave new world that has such people in it."
The separator is: "undefined"
The array has 1 elements: Oh brave new world that has such people in it.

The original string is: "Jan,Feb,Mar,Apr,May,Jun,Jul,Aug,Sep,Oct,Nov,Dec"
The separator is: ","
The array has 12 elements: Jan / Feb / Mar / Apr / May / Jun / Jul / Aug / Sep / Oct / Nov / Dec
</pre>

<h3 id="Removing_spaces_from_a_string">Removing spaces from a string</h3>

<p>In the following example, <code>split()</code> looks for zero or more spaces, followed by a semicolon, followed by zero or more spaces—and, when found, removes the spaces and the semicolon from the string. <code>nameList</code> is the array returned as a result of <code>split()</code>.</p>

<pre class="brush: js notranslate">const names = 'Harry Trump ;Fred Barney; Helen Rigby ; Bill Abel ;Chris Hand '

console.log(names)

const re = /\s*(?:;|$)\s*/
const nameList = names.split(re)

console.log(nameList)
</pre>

<p>This logs two lines; the first line logs the original string, and the second line logs the resulting array.</p>

<pre class="notranslate">Harry Trump ;Fred Barney; Helen Rigby ; Bill Abel ;Chris Hand
[ "Harry Trump", "Fred Barney", "Helen Rigby", "Bill Abel", "Chris Hand", "" ]
</pre>

<h3 id="Returning_a_limited_number_of_splits">Returning a limited number of splits</h3>

<p>In the following example, <code>split()</code> looks for spaces in a string and returns the first 3 splits that it finds.</p>

<pre class="brush: js notranslate">const myString = 'Hello World. How are you doing?'
const splits = myString.split(' ', 3)

console.log(splits)
</pre>

<p>This script displays the following:</p>

<pre class="notranslate">["Hello", "World.", "How"]
</pre>

<h3 id="Splitting_with_a_RegExp_to_include_parts_of_the_separator_in_the_result">Splitting with a <code>RegExp</code> to include parts of the separator in the result</h3>

<p>If <code><var>separator</var></code> is a regular expression that contains capturing parentheses <code>(</code><code>)</code>, matched results are included in the array.</p>

<pre class="brush: js notranslate">const myString = 'Hello 1 word. Sentence number 2.'
const splits = myString.split(/(\d)/)

console.log(splits)
</pre>

<p>This script displays the following:</p>

<pre class="notranslate">[ "Hello ", "1", " word. Sentence number ", "2", "." ]
</pre>

<div class="notecard note">
<p><strong>Note: </strong><code>\d</code> matches the <a href="/en-US/docs/Web/JavaScript/Guide/Regular_Expressions/Character_Classes">character class</a> for digits between 0 and 9.</p>
</div>

<h3 id="Reversing_a_String_using_split">Reversing a String using <code>split()</code></h3>

<div class="warning">
<p>This is not a robust way to reverse a string:</p>

<pre class="brush: js example-bad notranslate">const str = 'asdfghjkl'
const strReverse = str.split('').reverse().join('')
// 'lkjhgfdsa'

// split() returns an array on which reverse() and join() can be applied
</pre>

<p>It doesn't work if the string contains grapheme clusters, even when using a unicode-aware split. (Use, for example, <a href="https://github.com/mathiasbynens/esrever">esrever</a> instead.)</p>

<pre class="brush: js example-bad notranslate">const str = 'résumé'
const strReverse = str.split(/(?:)/u).reverse().join('')
// =&gt; "́emuśer"
</pre>

<p><strong>Bonus:</strong> use {{jsxref("Operators/Comparison_Operators", "===", "#Identity_strict_equality_(===)")}} operator to test if the original string was a palindrome.</p>
</div>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <thead>
  <tr>
   <th scope="col">Specification</th>
  </tr>
 </thead>
 <tbody>
  <tr>
   <td>{{SpecName('ESDraft', '#sec-string.prototype.split', 'String.prototype.split')}}</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p class="hidden">The compatibility table in this page is generated from structured data. If you'd like to contribute to the data, please check out <a href="https://github.com/mdn/browser-compat-data">https://github.com/mdn/browser-compat-data</a> and send us a pull request.</p>

<p>{{Compat("javascript.builtins.String.split")}}</p>

<h2 id="See_also">See also</h2>

<ul>
 <li>{{jsxref("String.prototype.charAt()")}}</li>
 <li>{{jsxref("String.prototype.indexOf()")}}</li>
 <li>{{jsxref("String.prototype.lastIndexOf()")}}</li>
 <li>{{jsxref("Array.prototype.join()")}}</li>
 <li><a href="/en-US/docs/Web/JavaScript/Guide/Regular_Expressions">Using regular expressions in JavaScript</a></li>
</ul>
